package org.communiquons.comunic.independentnotifications;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.PowerManager;
import android.provider.Settings;

import androidx.annotation.NonNull;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

public class NotificationsChannel implements MethodChannel.MethodCallHandler {
    private final Context context;

    public NotificationsChannel(Activity context) {
        this.context = context.getApplicationContext();
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull MethodChannel.Result result) {
        try {


            if (call.method.equals("preConfigure"))
                preConfigure(result);

            else
                result.notImplemented();
        } catch (Exception e) {
            e.printStackTrace();
            result.error("Failed to execute native code!", e.getMessage(), null);
        }

    }

    /**
     * Pre-configure independent notifications service
     */
    private void preConfigure(@NonNull MethodChannel.Result result) throws Exception {
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.M) {
            if (!context.getSystemService(PowerManager.class).isIgnoringBatteryOptimizations(context.getPackageName())) {
                @SuppressLint("BatteryLife")
                Intent intent = new Intent(Settings.ACTION_REQUEST_IGNORE_BATTERY_OPTIMIZATIONS,
                        Uri.parse("package:" + context.getPackageName()));
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

                context.startActivity(intent);
            }
        }

        result.success(null);
    }

}
